# OpenAPI

[![Build Status](https://github.com/JuliaComputing/OpenAPI.jl/workflows/CI/badge.svg)](https://github.com/JuliaComputing/OpenAPI.jl/actions?query=workflow%3ACI+branch%3Amain)
[![codecov.io](http://codecov.io/github/JuliaComputing/OpenAPI.jl/coverage.svg?branch=main)](http://codecov.io/github/JuliaComputing/OpenAPI.jl?branch=main)

This is the Julia library needed along with code generated by the [OpenAPI generator](https://openapi-generator.tech/) to help define, produce and consume OpenAPI interfaces.

[![](https://img.shields.io/badge/docs-latest-blue.svg)](https://JuliaComputing.github.io/OpenAPI.jl)

## Quick Guide

- Create an API specification. Check out [OpenAPI-Spec](https://github.com/OAI/OpenAPI-Specification) for specification syntax and examples.
- Use [instructions](https://openapi-generator.tech/docs/generators) provided for the Julia OpenAPI code generator plugin to generate Julia code.
- Client:
    - Use the generated client in Julia directly to invoke APIs
- Server:
    - Provide code to handle API invocations on the server side by implementing the Julia methods corresponding to API stubs.
    - Start a server using HTTP.jl and register the generated request handlers.

## Examples

The Petstore is a common example that most OpenAPI implementations use to test and demonstrate. Clients and servers generated from both version 2 and 3 specifications are included in this repo.

- Petstore v2:
    - Client: [docs](test/client/petstore_v2/petstore/README.md), [implementation](test/client/petstore_v2)
    - Server: [docs](test/server/petstore_v2/petstore/README.md), [implementation](test/server/petstore_v2)
- Petstore v3:
    - Client: [docs](test/client/petstore_v3/petstore/README.md), [implementation](test/client/petstore_v3)
    - Server: [docs](test/server/petstore_v3/petstore/README.md), [implementation](test/server/petstore_v3)
