# Julia API client for FormsClient

Tests for different types of POST operations with forms and file uploads

## Overview
This API client was generated by the [OpenAPI Generator](https://openapi-generator.tech) project.  By using the [openapi-spec](https://openapis.org) from a remote server, you can easily generate an API client.

- API version: 0.1.0
- Build package: org.openapitools.codegen.languages.JuliaClientCodegen


## Installation
Place the Julia files generated under the `src` folder in your Julia project. Include FormsClient.jl in the project code.
It would include the module named FormsClient.

Documentation is generated as markdown files under the `docs` folder. You can include them in your project documentation.
Documentation is also embedded in Julia which can be used with a Julia specific documentation generator.

## API Endpoints

Class | Method
------------ | -------------
*DefaultApi* | [**post_urlencoded_form**](docs/DefaultApi.md#post_urlencoded_form)<br/>**POST** /test/{form_id}/post_urlencoded_form_data<br/>posts a urlencoded form, with file contents and additional metadata, both of which are strings
*DefaultApi* | [**upload_binary_file**](docs/DefaultApi.md#upload_binary_file)<br/>**POST** /test/{file_id}/upload_binary_file<br/>uploads a binary file given its path, along with some metadata
*DefaultApi* | [**upload_text_file**](docs/DefaultApi.md#upload_text_file)<br/>**POST** /test/{file_id}/upload_text_file<br/>uploads text file contents along with some metadata


## Models

 - [TestResponse](docs/TestResponse.md)


<a id="authorization"></a>
## Authorization
Endpoints do not require authorization.


## Author



