# Julia API server for ModelGenServer

Model Generation Tests

## Overview
This API server was generated by the [OpenAPI Generator](https://openapi-generator.tech) project.  By using the [openapi-spec](https://openapis.org) from a remote server, you can easily generate an API client.

- API version: 0.1.0
- Build package: org.openapitools.codegen.languages.JuliaServerCodegen


## Installation
Place the Julia files generated under the `src` folder in your Julia project. Include ModelGenServer.jl in the project code.
It would include the module named ModelGenServer.

Implement the server methods as listed below. They are also documented with the ModelGenServer module.
Launch a HTTP server with a router that has all handlers registered. A `register` method is provided in ModelGenServer module for convenience.

```julia
register(
    router::HTTP.Router,        # Router to register handlers in
    impl;                       # Module that implements the server methods
    path_prefix::String="",     # Prefix to be applied to all paths
    optional_middlewares...     # Optional middlewares to be applied to all handlers
)
```

Optional middlewares can be one or more of:
- `init`: called before the request is processed
- `pre_validation`: called after the request is parsed but before validation
- `pre_invoke`: called after validation but before the handler is invoked
- `post_invoke`: called after the handler is invoked but before the response is sent

The order in which middlewares are invoked are:
`init |> read |> pre_validation |> validate |> pre_invoke |> invoke |> post_invoke`


## API Endpoints

The following server methods must be implemented:

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DefaultApi* | [**test**](docs/DefaultApi.md#test) | **GET** /test | Test



## Models

 - [ComputeType](docs/ComputeType.md)
 - [TestModel](docs/TestModel.md)



## Author



